import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.Map; 
import processing.pdf.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Data_med_iconsFinal extends PApplet {




Table data;
String name;
String realname;
float correct, partial, incorrect, fatal;
String[] sortOptions = {
  "symbol #", "% correct", "% partial", "% incorrect", "% fatal"
};
int currentSortOption = 0;
PImage icon;
HashMap<String, PImage> icons = new HashMap<String, PImage>();
PFont Futura;
int i;
float a;
float xVal, yVal;

public void setup() {    
  size(1400, 800,"processing.core.PGraphicsRetina2D");
  //size(1400, 800,PDF,"doc.pdf");
  
  //for pdf
  textMode(SHAPE);
  Futura = createFont("Futura-Medium", 10);
  Futura = createFont("Futura-Medium", 24);
  // 
  
  // for normal
   //Futura = loadFont("Futura-Medium-10.vlw");   
  //
  
  background(0);
  smooth();
  //frameRate(10);

  a=28.0f;

  i=1;

  data = loadTable("data.csv", "header");

  for ( TableRow row : data.rows () ) {
    name = row.getString("symbol #");
    println("MA06");
    icons.put(name, loadImage("icons/"+name+".png"));
  }
}


public void draw() {
  background(60);
  fill(255);

  println(i);

  textFont(Futura);
  textSize(24);
  text(sortOptions[currentSortOption], 6*a, 6*a);
  text("sorted according to", 6*a, 6*a-30);

  pushMatrix();
  rectMode(CENTER);
  stroke(0, 255, 0, 60);
  strokeWeight(a/5);
  line(7*a, 25.5f*a, 6*a, 25.5f*a);
  textSize(9);
  text("correct", 7.5f*a, 25.65f*a);
  stroke(0, 255, 255, 60);
  line(7*a, 26*a, 6*a, 26*a);
  text("partial", 7.5f*a, 26.15f*a);

  // translate and legend for incorrect + fatal
  translate(3.5f*a, 0);
  stroke(255, 100, 50, 60);
  line(7*a, 25.5f*a, 6*a, 25.5f*a);
  text("partial", 7.5f*a, 25.65f*a);
  stroke(255, 0, 0, 60);
  line(7*a, 26*a, 6*a, 26*a);
  text("fatal", 7.5f*a, 26.15f*a);
  popMatrix();

  translate(7*a, 9*a);  

  for (TableRow row : data.rows ()) {      

    name = row.getString("symbol #");
    realname = row.getString("#");
    icon = icons.get(name);

    correct = (parseInt( row.getString("# correct")))*5;
    partial = (parseInt( row.getString("# partial")))*5;
    incorrect = (parseInt( row.getString("# incorrect")))*5;
    fatal = (parseInt( row.getString("# fatal")))*5;

    pushMatrix();
    xVal = 7*a + 3.5f*a*((i-1)%11); // center of drawing in each grid
    yVal = 9*a + 3.5f*a*((i-1)/11);

    if (mouseX > xVal - 50 && mouseX < xVal + 50 &&  // ------------------------------------------------
    mouseY > yVal -50 && mouseY < yVal + 50) {
      scale(1.4f, 1.4f);
    }

    image(icon, -a/2, -a/2, a, a);
    strokeCap(SQUARE);
    noFill();
    strokeWeight(a/5);

    textSize(10);
    text(realname, -a, -1.3f*a);
    stroke(0, 255, 0, 60);
    arc(0, 0, a*2, a*2, 0, PI*correct/50.0f);
    rotate(PI*correct/50.0f);

    stroke(0, 255, 255, 60);
    arc(0, 0, a*2, a*2, 0, PI*partial/50.0f);
    rotate(PI*partial/50.0f);

    stroke(255, 100, 50, 60);
    arc(0, 0, a*2, a*2, 0, PI*incorrect/50.0f);
    rotate(PI*incorrect/50.0f);

    stroke(255, 0, 0, 60);
    arc(0, 0, a*2, a*2, 0, PI*fatal/50.0f);

    popMatrix();

    i=i+1;
    println(i);

    if ((i==12) || (i==23) || (i==34) || (i==45) ) {
      translate(-a*35, a*3.5f);
    } else {
      translate(a*3.5f, 0);
    }
  }    
  i = 1;
  //exit();
}


public void mousePressed( ) {
  currentSortOption = (currentSortOption+1)% sortOptions.length;        
  data.sort(sortOptions[currentSortOption]);     
  loop();
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "--full-screen", "--bgcolor=#666666", "--stop-color=#cccccc", "Data_med_iconsFinal" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
